// STexture.h: Schnittstelle fr die Klasse STexture.
//
// Copyright by Andr Stein
// E-Mail: andre_stein@gmx.de, andre_stein@web.de
// http://www.steinsoft.net
//////////////////////////////////////////////////////////////////////

#ifndef S_TGA_TEXTURE_H
#define S_TGA_TEXTURE_H

#ifdef WIN32
#include <windows.h>
#endif

#include <GL/gl.h>
#include <GL/glu.h>

//Structs
struct STGA
{
        STGA()
        {
                data = (unsigned char*)0;
                width = 0;
                height = 0;
                byteCount = 0;
        }

	~STGA() { delete[] data; data = 0; }

	void destroy() { delete[] data; data = 0; }

        int width;
	int height;
        unsigned char byteCount;
        unsigned char* data;
};

class STGATexture
{
public:
	void destroy();

	/////////////
	// Konstruktoren
	///////////////
	STGATexture();
	STGATexture(const char* filename,int minFilter = GL_LINEAR,
		int magFilter = GL_LINEAR, bool clampToEdge = false);


        virtual ~STGATexture();

	/////////////////
	// Funktionen
	////////////////

	virtual bool createMipmap(const char* filename,int minFilter = GL_LINEAR_MIPMAP_NEAREST,
		int magFilter = GL_LINEAR, bool clampToEdge = false);
	virtual bool createTexture(const char* filename, int minFilter = GL_LINEAR,
		int magFilter = GL_LINEAR, bool clampToEdge = false);

	void select();

	GLuint getGLTexture();
private:
	bool loadTGA(const char* filename, STGA& tgaFile);
protected:
	GLuint texture;
};

#endif
